import { MultiselectDatasource } from '@genesislcap/foundation-ui';
import { mapStateToControlProps, rankWith } from '@jsonforms/core';
import { html } from '@microsoft/fast-element';
import { isOneOfOptionMultiselect } from '../testers/isOneOfOptionMultiselect';
import { MULTISELECT_CONTROL_RANK } from './RenderersRanks';
MultiselectDatasource;
export const ConnectedMultiselectControlRendererTemplate = (prefix = 'zero') => html `
  <template>
    <control-wrapper
      :control=${(x) => x.control}
      :touched=${(x) => x.touched}
      ?submitted=${(x) => x.submitted}
    >
      <${prefix}-multiselect
        style="width: 100%"
        :selectedOptions=${(x) => x.control.data || []}
        @selectionChange=${(x, c) => {
    x.control.handleChange(x.control.path, c.event.detail);
    x.onBlur();
}}
        id=${(x) => x.control.path}
        data-test-id=${(x) => x.control.path}
      >
        <multiselect-datasource
          resourceName=${(x) => x.control.uischema.options?.allOptionsResourceName}
          value-field=${(x) => x.control.uischema.options?.valueField}
          label-field=${(x) => x.control.uischema.options?.labelField}
          :datasourceConfig=${(x) => x.control.uischema.options?.datasourceConfig}
        ></multiselect-datasource>
      </${prefix}-multiselect>
    </control-wrapper>
  </template>
`;
export const ConnectedMultiselectControlRendererEntry = {
    renderer: html `
    ${(x) => ConnectedMultiselectControlRendererTemplate(x.prefix)}
  `,
    tester: rankWith(MULTISELECT_CONTROL_RANK, isOneOfOptionMultiselect),
    mapper: mapStateToControlProps,
};
