import { OptionsDatasource } from '@genesislcap/foundation-ui';
import { mapStateToControlProps, or, rankWith } from '@jsonforms/core';
import { html } from '@microsoft/fast-element';
import { optionIs } from '../testers/optionIs';
import { SELECT_CONTROL_RANK } from './RenderersRanks';
OptionsDatasource;
export const ConnectedSelectControlRendererTemplate = (prefix = 'zero') => html `
  <template>
    <control-wrapper
      :control=${(x) => x.control}
      :touched=${(x) => x.touched}
      ?submitted=${(x) => x.submitted}
    >
      <${prefix}-combobox
        style="width: 100%"
        placeholder=${(x) => x.control.uischema.placeholder || x.control.label}
        ?disabled=${(x) => !x.control.enabled}
        @value-change=${(x, c) => {
    const value = c.event.detail?.value;
    x.control.handleChange(x.control.path, value);
    x.onBlur();
}}
        id=${(x) => x.control.path}
        data-test-id=${(x) => x.control.path}
      >
        <options-datasource
          resourceName=${(x) => x.control.uischema.options?.allOptionsResourceName}
          value-field=${(x) => x.control.uischema.options?.valueField}
          label-field=${(x) => x.control.uischema.options?.labelField}
          :datasourceConfig=${(x) => x.control.uischema.options?.datasourceConfig}
          :data=${(x) => x.control.uischema.options?.data}
          :initialSelectedValue=${(x) => x.control.data}
        ></options-datasource>
      </${prefix}-combobox>
    </control-wrapper>
  </template>
`;
export const ConnectedSelectControlRendererEntry = {
    renderer: html `
    ${(x) => ConnectedSelectControlRendererTemplate(x.prefix)}
  `,
    tester: rankWith(SELECT_CONTROL_RANK, or(optionIs('allOptionsResourceName'), optionIs('data'))),
    mapper: mapStateToControlProps,
};
