import { mapStateToControlProps, rankWith } from '@jsonforms/core';
import { html } from '@microsoft/fast-element';
import { isDate } from '../testers/isDate';
import { DATE_CONTROL_RANK } from './RenderersRanks';
export const DateControlRendererTemplate = (prefix = 'zero') => html `
  <template>
    <control-wrapper :control=${(x) => x.control} ?submitted=${(x) => x.submitted}>
      <${prefix}-text-field
        :value=${(x) => x.control.data?.min === undefined || x.control.data?.min === null
    ? ''
    : new Intl.DateTimeFormat('fr-CA', {
        year: 'numeric',
        month: '2-digit',
        day: '2-digit',
    }).format(x.control.data.min)}
        id=${(x) => `min-${x.control.path}`}
        type="date"
        data-test-id=${(x) => `min-${x.control.path}`}
        @blur=${(x, c) => {
    const value = c.event.target.control.valueAsNumber;
    x.control.handleChange(x.control.path, {
        min: value ? value : undefined,
        max: x.control.data?.max < value ? undefined : x.control.data?.max,
        type: 'date',
    });
    x.onBlur();
}}
        style="width: 100%"
      ></${prefix}-text-field>
      <${prefix}-text-field
        :value=${(x) => x.control.data?.max === undefined || x.control.data?.max === null
    ? ''
    : new Intl.DateTimeFormat('fr-CA', {
        year: 'numeric',
        month: '2-digit',
        day: '2-digit',
    }).format(x.control.data.max)}
        id=${(x) => `max-${x.control.path}`}
        type="date"
        data-test-id=${(x) => `max-${x.control.path}`}
        @blur=${(x, c) => {
    const value = c.event.target.control.valueAsNumber;
    x.control.handleChange(x.control.path, {
        min: x.control.data?.min > value ? undefined : x.control.data?.min,
        max: value ? value : undefined,
        type: 'date',
    });
    x.onBlur();
}}
        style="width: 100%"
      ></${prefix}-text-field>
    </control-wrapper>
  </template>
`;
export const FilterDateControlRendererEntry = {
    renderer: html `
    ${(x) => DateControlRendererTemplate(x.prefix)}
  `,
    tester: rankWith(DATE_CONTROL_RANK, isDate),
    mapper: mapStateToControlProps, // TODO: change mapper to handle dates instead of doing it in the template
};
