import { mapStateToControlProps, rankWith } from '@jsonforms/core';
import { html } from '@microsoft/fast-element';
import { isOneOfNumber } from '../testers/isOneOfNumber';
import { NUMBER_CONTROL_RANK } from './RenderersRanks';
export const FilterNumberControlRendererTemplate = (prefix = 'zero') => html `
  <template>
    <control-wrapper :control=${(x) => x.control} ?submitted=${(x) => x.submitted}>
      <${prefix}-text-field
        :value=${(x) => (x.control.data?.min === undefined ? '' : x.control.data.min)}
        @change=${(x, c) => {
    const value = parseFloat(c.event.target.value);
    return x.control.handleChange(x.control.path, !isNaN(value)
        ? {
            min: value,
            max: x.control.data?.max < value ? undefined : x.control.data?.max,
            type: 'number',
        }
        : { ...x.control.data, min: undefined });
}}
        placeholder="Min"
        id=${(x) => `min-${x.control.path}`}
        data-test-id=${(x) => `min-${x.control.path}`}
        @blur=${(x) => x.onBlur()}
        style="width: 100%"
      ></${prefix}-text-field>
      <span
        style="
        font-size: xx-large; 
        color: rgb(135, 155, 166);"
      >
        -
      </span>
      <${prefix}-text-field
        :value=${(x) => (x.control.data?.max === undefined ? '' : x.control.data.max)}
        @change=${(x, c) => {
    const value = parseFloat(c.event.target.value);
    return x.control.handleChange(x.control.path, !isNaN(value)
        ? {
            min: x.control.data?.min > value ? undefined : x.control.data?.min,
            max: value,
            type: 'number',
        }
        : { ...x.control.data, max: undefined });
}}
        placeholder="Max"
        id=${(x) => `max-${x.control.path}`}
        data-test-id=${(x) => `max-${x.control.path}`}
        @blur=${(x) => x.onBlur()}
        style="width: 100%"
      ></${prefix}-text-field>
    </control-wrapper>
  </template>
`;
export const FilterNumberControlRendererEntry = {
    renderer: html `
    ${(x) => FilterNumberControlRendererTemplate(x.prefix)}
  `,
    tester: rankWith(NUMBER_CONTROL_RANK, isOneOfNumber),
    mapper: mapStateToControlProps,
};
